#pragma semicolon 1

#include <sourcemod>
#include <sdkhooks>
#include <dhooks>

#define PLUGIN_NAME 	"GameUI Crash Fix"
#define PLUGIN_VERSION 	"1.0.0"

new Handle:g_hAcceptInput = INVALID_HANDLE;

public Plugin:myinfo =
{
	name = PLUGIN_NAME,
	author = "GoD-Tony",
	description = "Fixes a crash in game_ui entities",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/showthread.php?t=261173"
};

public OnPluginStart()
{
	// Convars.
	CreateConVar("sm_gameuifix_version", PLUGIN_VERSION, PLUGIN_NAME, FCVAR_PLUGIN|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	
	// Gamedata.
	new Handle:hConfig = LoadGameConfigFile("gameuifix.games");
	
	if (hConfig == INVALID_HANDLE)
	{
		SetFailState("Could not find gamedata file: gameuifix.games.txt");
	}
	
	new offset = GameConfGetOffset(hConfig, "AcceptInput");
	
	if (offset == -1)
	{
		SetFailState("Failed to find AcceptInput offset");
	}
	
	CloseHandle(hConfig);
	
	// DHooks.
	g_hAcceptInput = DHookCreate(offset, HookType_Entity, ReturnType_Bool, ThisPointer_CBaseEntity, Hook_AcceptInput);
	DHookAddParam(g_hAcceptInput, HookParamType_CharPtr);
	DHookAddParam(g_hAcceptInput, HookParamType_CBaseEntity);
	DHookAddParam(g_hAcceptInput, HookParamType_CBaseEntity);
	DHookAddParam(g_hAcceptInput, HookParamType_Object, 20); //varaint_t is a union of 12 (float[3]) plus two int type params 12 + 8 = 20
	DHookAddParam(g_hAcceptInput, HookParamType_Int);
}

public OnEntityCreated(entity, const String:classname[])
{
	if (StrEqual(classname, "game_ui"))
	{
		DHookEntity(g_hAcceptInput, false, entity);
	}
}

public MRESReturn:Hook_AcceptInput(thisptr, Handle:hReturn, Handle:hParams)
{
	new String:sCommand[128];
	DHookGetParamString(hParams, 1, sCommand, sizeof(sCommand));
	
	if (StrEqual(sCommand, "Deactivate"))
	{
		new pPlayer = GetEntPropEnt(thisptr, Prop_Data, "m_player");
		
		if (pPlayer == -1)
		{
			// Manually disable think.
			SetEntProp(thisptr, Prop_Data, "m_nNextThinkTick", -1);
			
			DHookSetReturn(hReturn, false);
			return MRES_Supercede;
		}
	}
	
	DHookSetReturn(hReturn, true);
	return MRES_Ignored;
}
